import java.util.ArrayList;
import java.util.Iterator;

/** 
 * The MyHashSet API is similar to the Java Set interface. This
 * collection is backed by a hash table.
 */
public class MyHashSet<E> implements Iterable<E> {

	/** Unless otherwise specified, the table will start as
	 * an array (ArrayList) of this size.*/
	private final static int DEFAULT_INITIAL_CAPACITY = 4;

	/** When the ratio of size/capacity exceeds this
	 * value, the table will be expanded. */
	private final static double MAX_LOAD_FACTOR = 0.75;

	/* STUDENTS: LEAVE THIS AS PUBLIC */
	public ArrayList<Node<E>> hashTable;

	private int size;  // number of elements in the table

	
	// STUDENTS: DO NOT ADD ANY OTHER INSTANCE VARIABLES OR STATIC
	// VARIABLES TO THIS CLASS!
	
	
	/* STUDENTS: LEAVE THIS PUBLIC, and do not modify the Node class. */
	public static class Node<T> {
		private T data;
		public Node<T> next;  // STUDENTS: Leave this public, too!

		private Node(T data) {
			this.data = data;
			next = null;
		}
	}

	/**
	 * Initializes an empty table with the specified capacity.  
	 *
	 * @param initialCapacity initial capacity (length) of the 
	 * underlying table
	 */
	// STUDENTS: Calling the ArrayList constructor that takes
	// an int argument doesn't do what we want here. 
	// You need to make an empty ArrayList, and then add a bunch 
	// of null values to it until the size reaches the 
	// initialCapacity requested.  
	public MyHashSet(int initialCapacity) {
		throw new UnsupportedOperationException("REMOVE THIS");
	}

	/**
	 * Initializes an empty table of length equal to 
	 * DEFAULT_INITIAL_CAPACITY
	 */
	// STUDENTS:  This constructor should just call the other
	// constructor
	public MyHashSet() {
		throw new UnsupportedOperationException("REMOVE THIS");
	}

	/**
	 * Returns the number of elements stored in the table.
	 * @return number of elements in the table
	 */
	public int size(){
		throw new UnsupportedOperationException("REMOVE THIS");
	}

	/**
	 * Returns the length of the table (the number of buckets).
	 * @return length of the table (capacity)
	 */
	public int getCapacity(){
		throw new UnsupportedOperationException("REMOVE THIS");
	}

	/** 
	 * Looks for the specified element in the table.
	 * 
	 * @param element to be found
	 * @return true if the element is in the table, false otherwise
	 */
	public boolean contains(Object element) {
		throw new UnsupportedOperationException("REMOVE THIS");
	}

	/** Adds the specified element to the collection, if it is not
	 * already present.  If the element is already in the collection, 
	 * then this method does nothing.
	 * 
	 * @param element the element to be added to the collection
	 */
	// STUDENTS:  After adding the element to the table, consider
	// the load factor. If it is greater than MAX_LOAD_FACTOR then 
	// you must double the size of the table. [Create a new table 
	// that is twice as big as the current one and then re-hash 
	// of all of the data from the old table into the new one.
	// Hint: It's OK to iterate over the original table.]
	public void add(E element) {
		throw new UnsupportedOperationException("REMOVE THIS");
	}

	/** Removes the specified element from the collection.  If the
	 * element is not present then this method should do nothing.
	 *
	 * @param element the element to be removed
	 * @return true if an element was removed, false if no element 
	 * removed
	 */
	public boolean remove(Object element) {
		throw new UnsupportedOperationException("REMOVE THIS");
	}

	/** Returns an Iterator that can be used to iterate over
	 * all of the elements in the collection.
	 * 
	 * The order of the elements is unspecified.
	 */
	// STUDENTS: You may NOT copy the data from the hash table
	// into a different structure.  You must write an iterator
	// that iterates over your hash table directly, without 
	// copying the data anywhere.
	@Override
	public Iterator<E> iterator() {
		throw new UnsupportedOperationException("REMOVE THIS");
	}

}
